;;;__________________________________________________________________________
;;; File name            : movend.lsp
;;; Version AutoCAD      : all US versions 
;;; Description          : Extend or cut lines and plines
;;; Date of creation     : 04/09/95 
;;; Date last modif.     : 
;;; FONCTIONS            : c:MovEnd
;;; Routines	         : none
;;; Code var. globales   : none - CA 109
;;;*************************************************************************
(defun c:MovEnd ( / Pt_Sel  Sub_Ligne  Sub_Poly  Commun  Des_L1  Nom_Ent1
		Pt_1	Pt_2	Sel1	Angl1	) 
  (setq oldcmd00 (getvar "cmdecho"))
  (setvar "cmdecho" 0) 
  (setq Pt_Sel 1)
  (setvar "orthomode" 0)
  (prompt "\nMove End Line or Pline ") 
;;;************************************************
  (defun Sub_Ligne (/ Pt_3 Code1) 
    (setq Pt_1 (CDR (ASSOC 10 Des_L1)) 
          Pt_2 (CDR (ASSOC 11 Des_L1)))
    (IF (> (DISTANCE Pt_Sel Pt_1) (DISTANCE Pt_Sel Pt_2)) 
      (setq Pt_3 Pt_1 
            Pt_1 Pt_2 
            Pt_2 Pt_3 
            Code1 11)
      (setq Code1 10)
    ) 
    (setq Angl1 (F_Angle_RR (angle Pt_2 Pt_1)))
    (Commun)  
    (entmod (SUBST (CONS Code1 Pt_1) (ASSOC Code1 Des_L1) Des_L1)) 
    (entupd Nom_Ent1)
  ) 
  ;;;*****************************************-
  (defun Sub_Poly ( / Des_Sgm1 Nom_Sgm1 Des_Sgm2 Nom_Sgm2) 
    (setq Des_Sgm1 (entget (setq Nom_Sgm1 (entnext Nom_Ent1))) 
          Pt_1 (cdr (assoc 10 Des_Sgm1)) 
          Des_Sgm2 (entget (setq Nom_Sgm2 (entnext Nom_Sgm1))) 
          Pt_2 (cdr (assoc 10 Des_Sgm2)))
    (while (and (/= (cdr (assoc 0 Des_Sgm2)) "SEQEND") 
                (null (inters Pt_1 Pt_2 Pt_Sel Pt_Sel))
           ) 
      (progn
        (setq Pt_1 Pt_2 
              Nom_Sgm1 Nom_Sgm2 
              Des_Sgm1 Des_Sgm2 
              Des_Sgm2 (entget (setq Nom_Sgm2 (entnext Nom_Sgm1))) 
              Pt_2 (cdr (assoc 10 Des_Sgm2)))
      )
    ) 
    (if (/= (cdr (assoc 0 Des_Sgm2)) "SEQEND") 
      (progn
        (setq Angl1 (F_Angle_RR (angle Pt_2 Pt_1)))
        (if (> (distance Pt_1 Pt_Sel) (distance Pt_2 Pt_Sel)) 
          (progn
            (setq Pt_1 Pt_2 
                  Des_Sgm1 Des_Sgm2 
                  Nom_Sgm1 Nom_Sgm2
		  Angl1 (F_Angle_RR (+ Angl1 pi)))
          )
        ) 
        (Commun)
        (entmod (subst (cons 10 Pt_1) (assoc 10 Des_Sgm1) Des_Sgm1)) 
        (entupd Nom_Sgm1)
      ) 
      (prompt "\nNothing find ...")
    )
  )         
  ;;;****************************************************************
  (defun Commun ( / Angl2 Dist1)
    (MENUCMD "s=osnapb") 
    (setq Dist1 (GETPOINT Pt_1 
             "\nNew end <Enter to give a value> : " ))
    (IF (NULL Dist1) 
      (PROGN
        (WHILE (NULL (setq Dist1 (GETDIST "\n\nGive the lenght to change : "))))
      ) 
      (PROGN
        (setq Angl2 (abs (- Angl1 (angle Pt_1 Dist1)))) 
        (setq Dist1 (* (DISTANCE Pt_1 Dist1) 
	       (IF (AND (> Angl2 (* 0.5 PI)) (< Angl2 (* 1.5 PI))) -1 1))
        )
      )
    ) 
    (setq Pt_1 (POLAR Pt_1 Angl1 Dist1))
  )
  ;;;*****************************************
  (DEFUN F_Angle_RR (Val_Angle) 
    (COND
      ((MINUSP Val_Angle) (+ PI PI Val_Angle)) 
      ((> Val_Angle (+ PI PI)) (- Val_Angle PI PI)) 
      (T
        Val_Angle
      )
    )
  ) 
  ;;;*****************************************
  (WHILE Pt_Sel 
    (setq Pt_Sel (cadr (setq Sel1 
           (entsel 
    "\nSelect line or pline end to modify <Exit>: " ))))
    (IF Pt_Sel
      (PROGN
        (setq Pt_Sel (osnap Pt_Sel "_near"))
        (setq Des_L1 (ENTGET (setq Nom_Ent1 (CAR Sel1))))
        (cond
          ((= (CDR (ASSOC 0 Des_L1)) "LINE") (Sub_Ligne)) 
          ((= "3DLINE" (cdr (assoc 0 Des_L1))) 
            (prompt "\n... MovEnd does not accept 3D lines ...")
          ) 
          ((and (= "POLYLINE" (cdr (assoc 0 Des_L1))) 
                (member (cdr (assoc 70 Des_L1)) '(0 2 4 6)))                         
           (Sub_Poly)
          ) 
          ((and (= "POLYLINE" (cdr (assoc 0 Des_L1))) 
             (member (cdr (assoc 70 Des_L1)) '(1 3 5 7)))                        
           (prompt "\n... MovEnd does not accept 2D closed plines 2D ...")
          ) 
          ((and (= "POLYLINE" (cdr (assoc 0 Des_L1))) 
             (>= (cdr (assoc 70 Des_L1)) 8))                       
           (prompt "\n... MovEnd does not accept this kind of entity ...")
          ) 
          (t nil )
        ) 
        (prompt "\n ")
      )
    )
  ) 
  (setvar "cmdecho" oldcmd00) 
  (princ)
) 

